<?php
/**
 * Plugin CINOTIF
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/actions');
include_spip('inc/editer');


function formulaires_cinotif_remplacer_domaine_charger_dist(){

	$valeurs = array();
	
	if (!autoriser('configurer', 'configuration'))
		return;

	$valeurs['ciedit'] = true;

	return $valeurs;
}


function formulaires_cinotif_remplacer_domaine_verifier_dist(){
        $erreurs = array();

	if (_request('domaineinitial')){
            if (!_request('domainefutur')){
		$erreurs['domainefutur'] = _T('info_obligatoire');
            } else {
                if (!cinotif_verifier_domaine(_request('domaineinitial')))
                    $erreurs['domaineinitial'] =  _T('cinotif:valeur_incorrecte');
                elseif (!cinotif_verifier_domaine(_request('domainefutur')))
                    $erreurs['domainefutur'] =  _T('cinotif:valeur_incorrecte');
                elseif (sql_countsel("spip_cinotif_evenements", "url_multisite LIKE '%"._request('domaineinitial')."%'")==0)
                    $erreurs['domaineinitial'] =  _T('cinotif:domaine_existe_pas');
            }
        } else {
		$erreurs['domaineinitial'] = _T('info_obligatoire');
        }

	return $erreurs;
}


function formulaires_cinotif_remplacer_domaine_traiter_dist(){
        $res = array();

        // remplacer un domaine
	if (_request('domaineinitial') AND _request('domainefutur')){
            $domaineinitial = _request('domaineinitial');
            $domainefutur = _request('domainefutur');
            
            $result = sql_select("*", "spip_syndic", "url_site LIKE '%".$domaineinitial."%'");
            while ($row = sql_fetch($result)) {
                sql_updateq("spip_syndic", array("url_site"=>str_replace($domaineinitial,$domainefutur,$row['url_site']), "url_syndic"=>str_replace($domaineinitial,$domainefutur,$row['url_syndic'])), "id_syndic=".$row['id_syndic']);
            }
            
            $result = sql_select("*", "spip_cinotif_evenements", "url_multisite LIKE '%".$domaineinitial."%'");
            while ($row = sql_fetch($result)) {
                sql_updateq("spip_cinotif_evenements", array("url_multisite"=>str_replace($domaineinitial,$domainefutur,$row['url_multisite'])), "id_evenement=".$row['id_evenement']);
            }
        }
        
        $res['message_ok'] = _T('remplacement_fait');
        
	return $res;	
}

function cinotif_verifier_domaine($domaine){
    $return = false;

    $tscs = str_replace(array('.','-','/','_'),'',$domaine);
    if (ctype_alnum($tscs))
            $return = true;

    return $return;
}

?>